#include <Wire.h>

#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeMono9pt7b.h>
#include<Fonts/FreeSans24pt7b.h>

#define SCREEN_WIDTH 128 // OLED longueur en pixel
#define SCREEN_HEIGHT 64 // OLED largeur pixels

#define OLED_RESET     4 // reset
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

/*---------------ADXL 345--------------------------------------*/
int x,y,z;
float pitch=0.02;
float roll=0.08;
byte buff[6];
int indice_r=0;
int indice_p=0;
float total_roll,total_pitch;

int moyenne_roll,moyenne_pitch;

#define device 0x53
#define BW_RATE 0x2c
#define POWER_CTL 0x2D
#define DATA_FORMAT 0x31
#define DATAX0 0x32
#define DATAX1 0x33
#define DATAY0 0x34
#define DATAY1 0x35
#define DATAZ0 0x36
#define DATAZ1 0x37


void write_data(byte adr,byte val){
Wire.beginTransmission(device);
Wire.write(adr);
Wire.write(val);
Wire.endTransmission();
}

void read_data(byte adr, int num,byte buff[]){
Wire.beginTransmission(device);
Wire.write(adr);
Wire.endTransmission();

Wire.beginTransmission(device);
Wire.requestFrom(device,num);
int i=0;
while(Wire.available()){
buff[i]=Wire.read();
i++;
}
Wire.endTransmission();
}

void read_adxl(){
read_data(DATAX0,6,buff);

 x=((int)buff[1]<<8)| buff[0];
 y=((int)buff[3]<<8)| buff[2];
 z=((int)buff[5]<<8)| buff[4];
 
 Serial.print(" dataX1 : ");
 Serial.print(buff[1],HEX);

 Serial.print(" dataX0 : ");
 Serial.print(buff[0],HEX);

 Serial.print(" x : ");
 Serial.println(x);

 Serial.print(" dataZ1 : ");
 Serial.print(buff[5],HEX);

 Serial.print(" dataZ0 : ");
 Serial.print(buff[4],HEX);

Serial.print(" z : ");
 Serial.println(z);
 Serial.println(" ");
 
}
/*-------------------------------------------------------------*/





void init_OLED(){
 display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // adresse I2C 0x3C
 display.clearDisplay();                    // efface de buffer de l'afficheur
 display.setFont(&FreeMono9pt7b);          // caractere de 9pt de 7 bit
 display.setTextSize(1);                    // setTextSize est facteur d'echelle
 display.setTextColor(WHITE);              // La couleur du texte
}


void setup() {
  Serial.begin(9600);
  Wire.begin();
  write_data(BW_RATE,0x0A);
  write_data(DATA_FORMAT,0x08);   // plus ou mois 2g
  write_data(POWER_CTL,0x08);
  init_OLED();
}


float degre=0;
float pente;

void aff_data(){
   display.clearDisplay();
   display.setCursor(8,10);             // On va écrire en x=8, y=10
   display.println("INCLINAISON");     // un println comme pour écrire sur le port série
   display.setCursor(0,30);            // On place le curseur
   display.print("pitch:");
   display.println(pitch,1);
   display.display();
   delay(20);
}

void loop() {
   read_adxl();
   roll  = (atan2(y,z)*180.0)/M_PI;
   pitch = (atan2(x,z)*180.0)/M_PI;
  aff_data();
  delay(100);
}
